//! \file    DefvalWindow.cpp
//! \brief   Implementation of the Defval window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

/*
  Nom du Fichier: DefvalWindow.cpp
  Nom de classe: DefvalWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include <iostream>
#include "Include/DefvalWindow.hpp"
//! \class DefvalWindow(QWidget *parent): QWidget(parent);
//! \brief Implementation of the Defval window for visual_YAO.

using namespace std;

/***************************************** The constructor **********************************************************************/

DefvalWindow::DefvalWindow(QWidget *parent): QWidget(parent) {  /*!< The constructor. */
	
	this->setWindowTitle("Directive Defval.");     /*!< To set the window's title. */
	isCalled = false;
		// Instanciation des classes.
		// Déclaration des boutons et champs de saisie de texte.

		compteur			= 0;
		
		m_labelNomDefval		= new QLabel("Constante: ");    /*!< QLabel for Nom de la constante . */
		m_labelValeurDefval		= new QLabel("Valeur: ");  /*!< QLabel for Valeur de la constante. */

		m_ligneNomDefval 		= new QLineEdit(this) ;    /*!< Name of the QLineEdit. */
		m_ligneValeurDefval		= new QLineEdit(this) ;   /*!< Value of the QLineEdit. */

		m_ajoutDefval			= new QPushButton("Ajouter", this);   /*!< QPushButton for Ajout. */
		m_DefvalHelpButton              = new QPushButton("De l'aide ?");   /*!< QPushButton for aide. */
		m_supDefval			= new QPushButton("Supprimer", this);  /*!< QPushButton for Supprimer. */
			m_supDefval->setDisabled(true);	  /*!< setDisabled is true. */
		m_saveDefvalButton		= new QPushButton("Enregistrer", this);   /*!< QPushButton for Enregistrer. */
			m_saveDefvalButton->setDisabled(true);
		m_quitDefval			= new QPushButton("Quitter", this);   /*!< QPushButton for Quitter. */

		QStringList horizontalHeaders;
			horizontalHeaders << "Constante(s)"  << "Valeur(s)" << " ";  /*!< added Nom Netward Entrees and sorties in table */
		vueDefval 			= new QTableWidget(0, 2);  /*!< QTableWidget's in whitch the objects are listed for thue view. */
			vueDefval->setEditTriggers(QAbstractItemView::NoEditTriggers); /*!< this ligne give no edit mode*/
			vueDefval->setShowGrid(false);  /*!< this ligne cover the grille in table */
			vueDefval->setSelectionBehavior(QAbstractItemView::SelectRows);  /*!< this ligne give a section of the ligne */
		   	vueDefval->setHorizontalHeaderLabels(horizontalHeaders); /*!< displays the QTableWidget */
	//--------- Les gestionnaires de positionnement.
		m_layoutH1Defval        	= new QHBoxLayout;
			m_layoutH1Defval->addWidget(m_saveDefvalButton);
	 		m_layoutH1Defval->addWidget(m_quitDefval);//m_ajoutDefval);
		m_layoutGDefval			= new QGridLayout;  /*!< set QGridLayout m-layoutGDefval */
		m_layoutGDefval->addWidget(m_labelNomDefval, 0, 2);
		m_layoutGDefval->addWidget(m_ligneNomDefval, 0, 3, 1, 2);
		m_layoutGDefval->addWidget(m_labelValeurDefval, 1, 2);
		m_layoutGDefval->addWidget(m_ligneValeurDefval, 1, 3, 1, 2);
		m_layoutGDefval->addWidget(m_DefvalHelpButton, 3, 1); /*!<  m_DefvalHelpButton in the QGridLayout */
		m_layoutGDefval->addWidget(vueDefval, 2, 2, 4, 3); /*!< added m_vueDefval in the QGridLayout */
		m_layoutGDefval->addWidget(m_ajoutDefval, 3, 5);  /*!< added m_ajoutDefval in the QGridLayout */
		m_layoutGDefval->addWidget(m_supDefval, 4, 5); /*!< added m_supDefval in the QGridLayout */
		m_layoutGDefval->addLayout(m_layoutH1Defval, 6, 2, 1, 3);  /*!< added m_saveDefvalButton in the QGridLayout */

	index = vueDefval->currentIndex();

	m_modeleListeNoms 			= new QStringListModel(m_listeNomsDefval);

	this->setLayout(m_layoutGDefval); //Activation du gestionnaire principal.

	// Gestion des connexions entre les widgets.
	connect(m_quitDefval, SIGNAL(clicked()), this, SLOT(close()));  /*!< slot for the close this windows*/
	connect(m_supDefval, SIGNAL(clicked()), this, SLOT(deleteDefvalRow())); /*!< To delete the object selected in the view*/
	connect(m_ajoutDefval, SIGNAL(clicked()), this, SLOT(addDefvalRow()));  /*!< This slot add the object in the view */
	connect(m_DefvalHelpButton, SIGNAL(clicked()), this, SLOT(callDefvalHelp())); /*!< This slot opens the help window */
	connect(m_saveDefvalButton, SIGNAL(clicked()), this, SLOT(saveDefvalData())); /*!< This slot save data in structure */

	this->setFixedWidth(baseSize().width() + 410);
}
/****************************************** addDefvalRow() method **********************************************/
void DefvalWindow::addDefvalRow() {

	addRow();				// Permet de créer une nouvelle dans le tableau d'affichage.

	testContenu(compteur);	// Permet de vérifier si une ligne est présente dans le tableau d'affichage.
							// Au cas échéant, on ne désactive pas les boutons "Enregistrer" et "Supprimer". 
	
    static int i = 1;
    static int j = 1;
	QString NomDefval = m_ligneNomDefval->text();
	QString ValDefval = m_ligneValeurDefval->text();


	for(int i1 = 0; i1 < NomDefval.size(); i1++)
		if(!((NomDefval.at(i1) >= QChar('a')&& NomDefval.at(i1) <= QChar('z')) || (NomDefval.at(i1) >= QChar('A')&& NomDefval.at(i1) <= QChar('Z')) //--------
		|| (NomDefval.at(i1) >= QChar('0')&& NomDefval.at(i1) <= QChar('9')) || (NomDefval.at(i1) == QChar('_')))) //|| (line1.isEmpty())
			{
				QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur exacte du nom de la constante.");
				return; // Arrêt de la méthode
			}
	for(int i2 = 0; i2 < ValDefval.size(); i2++)
		if(!((ValDefval.at(i2) >= QChar('a') && ValDefval.at(i2) <= QChar('z')) || (ValDefval.at(i2) >= QChar('A')&& ValDefval.at(i2) <= QChar('Z')) 
		||(ValDefval.at(i2) >= QChar('0') && ValDefval.at(i2) <= QChar('9')) || (ValDefval.at(i2) == QChar('_')) || (ValDefval.at(i2) == QChar('-')) || (ValDefval.at(i2) == QChar('E')) || (ValDefval.at(i2) == QChar('e')) || (ValDefval.at(i2) == QChar('+')) || (ValDefval.at(i2) == QChar('.')))) //|| (line1.isEmpty())
			{
				QMessageBox::critical(this, "Erreur", "Veuillez entrer une valeur correcte pour la constante.");
				return; // Arrêt de la méthode
			}
	if ( m_ligneNomDefval->text().isEmpty())
		{
		QMessageBox::critical(this, "Erreur", "Le champ du nom de la constante est vide: entrer un nom SVP!");
		return; // Arrêt de la méthode
		}

	if ((i!=0)&&(j!=0)) {
		if (isCalled) {--i ; isCalled = false; }

	addNameInTable(i, j, m_ligneNomDefval->text());
	m_listeNomsDefval.append(m_ligneNomDefval->text() + " " + m_ligneValeurDefval->text());
	addValueInTable(i, j, m_ligneValeurDefval->text());

	i++;
	}

	initialiserChamps();
}
/************************************ deleteDefvalRow() method ****************************************************/
void DefvalWindow::deleteDefvalRow() {

	vueDefval->removeRow(vueDefval->currentRow());
	isCalled = true;
	-- compteur;
	testContenu(compteur);
}

/****************************************************************************************/
void DefvalWindow::addNameInTable(int ligne, int colonne, QString nomDefval) {

	QTableWidgetItem *chaine = new QTableWidgetItem;
		chaine->setText(nomDefval);

	vueDefval->setItem(ligne-1, colonne-1, new QTableWidgetItem(nomDefval));
}

/****************************************************************************************/
void DefvalWindow::addValueInTable(int ligne, int colonne, QString valeurDefval) {

	QTableWidgetItem *chaine = new QTableWidgetItem;
		chaine->setText(valeurDefval);

	vueDefval->setItem(ligne - 1, colonne, chaine);
}

/****************************************************************************************/
void DefvalWindow::addRow() {

	int row = vueDefval->rowCount();
	vueDefval->insertRow(row);
	compteur ++;
}
/****************************************************************************************/
void DefvalWindow::saveDefvalData() {

	QTableWidgetItem *cell1 = new QTableWidgetItem;
	QTableWidgetItem *cell2 = new QTableWidgetItem;	
	
	for (int i = 0; i < vueDefval->rowCount() ; i++) {
			cell1 = vueDefval->item(i,0);
			cell2 = vueDefval->item(i,1);
				
			defvalData.push_back(cell1->text() + " " + cell2->text());

	}
	//for (QStringList::iterator it = defvalData.begin(); it != defvalData.end(); it++)
	//cout << "Voici les valeurs ajoutées: " << it->toStdString() <<endl;
	m_quitDefval->setEnabled(true);
}
/****************************************************************************************/
void DefvalWindow::initialiserChamps() {

	m_ligneNomDefval->setText("");
	m_ligneValeurDefval->setText("");
}

/************************************ Implémentation de la méthode callHelpDefval ****************************************/
void DefvalWindow::callDefvalHelp()
{
	QMessageBox::about(this, tr("Aide sur la directive defval."),("<p> La directive defval permet d'associer un nom symbolique à une valeur."
                                                                  "<p><u>Exemple 1</u>: defval szx 12 <p><u>Exemple 2</u>: defval szy \"chaine\"<p> <u>Exemple 3</u>: defval szz szx"
                                                                  "<p> Pour plus d'informations sur defval, <a href=\"help/defval_aide.html\">cliquez ici.</a>"));
}

/****************************************************************************************/
void DefvalWindow::ouvrirProjetExistant() {

	 QStringList filtres;

	fd = new QFileDialog(this);
		fd->setDirectory(".");
		fd->setFileMode (QFileDialog::AnyFile);

	filtres	 << "*.*"
			 << "Tous les fichiers (*.*)";
		fd->setFilters(filtres);
		lstF = fd->getSaveFileName();
}
/****************************************************************************************************************************/
QStringList DefvalWindow::getDataDefval() {

	return defvalData;
}

/************************************ testContenu() ***************************************************/
bool DefvalWindow::testContenu(int anInt) {

	if (anInt != 0) {
		m_supDefval->setEnabled(true);
		m_saveDefvalButton->setEnabled(true);
	}
	else
	{
		m_supDefval->setDisabled(true);
		m_saveDefvalButton->setDisabled(true);
	}
}

/****************************************************************************************/
void DefvalWindow::closeEvent(QCloseEvent *event) {
	
      if (maybeSave()) {
            //writeSettings();
            event->accept();
      } 
	else 
            event->ignore();
      
}
/***************************************************************************************************************/
bool DefvalWindow::maybeSave()
{
      if (isWindowModified()) {
            int ret = QMessageBox::warning(this, tr("Application"),
                        tr("The document has been modified.\n"
                        "Do you want to save your changes?"),
                        QMessageBox::Yes | QMessageBox::Default,
                        QMessageBox::No,
                        QMessageBox::Cancel | QMessageBox::Escape);
            if (ret == QMessageBox::Yes)
	     return true;//return save();
            else if (ret == QMessageBox::Cancel)
            return false;
      }
      return true;
}	

/************************************************************************************/

/*bool DefvalWindow::enregDataDefval(bool tar) {

	saveDefvalData();//return defvalData;
	return tar;
}*/
/********************************************************************************/


