//! \file    HatNameWindow.cpp
//! \brief   Implementation of the HatName window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.


#include "Include/HatNameWindow.hpp"

//! \class HatNameWindow(string param1, QWidget *parent) : QWidget(parent)
//! \brief Implementation of the HatName window for visual_YAO.


using namespace std; //! \namespace std
using namespace yao; //! \namespace yao

/*************************************** Implémentation du constructeur **************************************************/
HatNameWindow::HatNameWindow(string param1, QWidget *parent) : QWidget(parent) {
 
	setWindowTitle("Directive Hatname."); // Titre de la fenetre.
	compteur 			= 0;
        
	m_labelNom1HatName	= new QLabel("Nom du fichier (.h): ");
	m_labelNom2HatName	= new QLabel("Recherche d'un fichier: ");
        m_comboHatName          = new QComboBox;		       //Champ de selection d'une constante
        m_boutonouvrir          = new QPushButton(this);	       //Déclaration du bouton "ouvrir" permettant de selectionner un fichier.
        m_boutonAjouter         = new QPushButton("Ajouter", this);    //Déclaration du bouton "ajouter"
        m_supHatName		= new QPushButton("Supprimer", this) ; //Déclaration du bouton "supprimmer"
			m_supHatName->setDisabled(true);
        m_enregHatName          = new QPushButton("Enregistrer", this);
        	m_enregHatName->setDisabled(true);
	m_quitHatName		= new QPushButton("Quitter", this);
        m_hatnameHelpButton     = new QPushButton("De l'aide ?", this);
        m_spacer                = new QSpacerItem(41, 21);

        m_comboHatName->setEditable(true);

               listeFichiers << param1.c_str();//this->getLocalProjectName().c_str();//NewProjectWindow::getNewProjectName().c_str();
        modeleFichiers = new QStringListModel(listeFichiers);


        vueFichiers = new QListView;
        vueFichiers->setModel(modeleFichiers);


	m_boutonouvrir->setIcon(QIcon("Images/icons/openfile.png")); //Affichage d'une image sur le bouton "ouvrir"
        m_boutonouvrir->raise();
        
        m_layoutHBas	= new  QHBoxLayout;
	
	m_layoutGHatName		= new QGridLayout ;
		m_layoutGHatName->addWidget(m_labelNom1HatName, 0, 1, Qt::AlignLeft);
		m_layoutGHatName->addWidget(m_comboHatName, 0, 2);

		m_layoutGHatName->addWidget(m_labelNom2HatName, 1, 1, Qt::AlignLeft);
		m_layoutGHatName->addWidget(m_boutonouvrir, 1, 2, Qt::AlignLeft);
				
		m_layoutGHatName->addWidget(m_hatnameHelpButton, 3, 0);
		m_layoutGHatName->addWidget(vueFichiers, 2, 1, 4, 2);

		m_layoutGHatName->addWidget(m_boutonAjouter, 3, 3);
		m_layoutGHatName->addWidget(m_supHatName, 4, 3);
	
		m_layoutHBas->addWidget(m_enregHatName);
		m_layoutHBas->addWidget(m_quitHatName);
		
		m_layoutGHatName->addLayout(m_layoutHBas, 7, 1, 1, 2);
		
	connect(m_quitHatName, SIGNAL(clicked()), this, SLOT(close()));
        connect(m_supHatName, SIGNAL(clicked()), this, SLOT(deleteHatRow()));
        connect(m_boutonouvrir , SIGNAL(clicked()), this, SLOT(ouvrirProjetExistant()));
        connect(m_quitHatName, SIGNAL(clicked()), this, SLOT(ecrireFichier()));
        //connect(m_enregHatName, SIGNAL(clicked()), this, SLOT(appelEnregistrer()));
        connect(m_boutonAjouter, SIGNAL(clicked()), this, SLOT(addHatRow()));
        connect(m_hatnameHelpButton, SIGNAL(clicked()), this, SLOT(callHatHelp()));

        this->setLayout(m_layoutGHatName);
		this->setFixedWidth(baseSize().width() + 450);
    }

/************************************* Implémentation de la méthode setNomFichierHat *************************************/
//! \fn void setNomFichierHat(QString nomFichierHat)

void HatNameWindow::setNomFichierHat(QString nomFichierHat) {

}

/************************************* Impémentation de la méthode getNomFichierHat() *************************************/
//! \fn string getNomFichierHat()

string HatNameWindow::getNomFichierHat() {

    return m_comboHatName->currentText().toStdString(); //! \return m_comboHatName->currentText().toStdString()
}
/************************************ Implémentation de la méthode appelEnregistrer() ************************************/
//! \fn void appelEnregistrer()

void HatNameWindow::appelEnregistrer() {

        for(QStringList::iterator it=listeFichiers.begin(); it!=listeFichiers.end(); it++)
                hatHeaderList.push_back(it->toStdString());
}

/************************************** Implémentation de la méthode setFileList *****************************************/


void HatNameWindow::setFileList(string localString) {  //! \fn void setFileList(string localString)

    listeFichiers.append(localString.c_str());

}

/****************************************************************************************/
void HatNameWindow::callHatHelp() {

QMessageBox::about(this, tr("Aide sur la directive hatname."),("<p> Première directive à déclarer obligatoirement dans tout projet Yao. Hatname permet d'intégrer en nombre limité dans le projet, les fichiers source.h. <p><u>Exemple</u>: hat_name nom_1 [nom_2 ...[nom_n]] <p> Pour plus d'informations sur la directive hatname, <a href=\"help/hatname_aide.html\">cliquez ici.</a> "));

}
/****************************************************************************************/

void HatNameWindow::addHatRow() {

hatFile = getNomFichierHat();
compteur ++;
testContenu(compteur);

for(int i=0; i < hatFile.size(); i++) {
    // stringLiteral of the YAO grammar:
    // (' ' | '\t')* ( 'a'..'z' | 'A'..'Z' | '/' | '_' | '-' | '.'| '0'..'9' )+ (' ' | '\t')*
    if(!((hatFile[i] >= 'a' && hatFile[i] <= 'z') ||
        (hatFile[i] >= 'A' && hatFile[i] <= 'Z') ||
        (hatFile[i] >= '0' && hatFile[i] <= '9') ||
        (hatFile[i] == '/')  ||
        (hatFile[i] == '_')  ||
        (hatFile[i] == '.')  ||
        (hatFile[i] == ' ')
        )){
            QMessageBox::about(this, tr("Erreur de saisie!"),
                               tr("<p>Vous avez saisi au moins un caractere non conforme!<p> Cliquer sur <b>ok</b> pour fermer cette fenetre."));
             return;
        }
 }

extension = static_cast<FilePath>(hatFile).getExtension();

if ((extension != ".h")){
    if (extension == "")
    {
        if (hatFile.length() != 0) {
            hatFile.append(".h");
            QString fichier = hatFile.c_str();
            //setFileList();
            //listeFichiers.removeFirst();
            listeFichiers.append(fichier);

            modeleFichiers->setStringList(listeFichiers);
            //testPresenceFichier();
            initialiserChamps();
        }

        return;

        }
    else
        QMessageBox::about(this, tr("Bad extension"),
                               tr("<p>L'extension du fichier n'est pas correcte."));
             return;
      }

QString fichier = hatFile.c_str();
listeFichiers.append(fichier);

modeleFichiers->setStringList(listeFichiers);
//testPresenceFichier();

initialiserChamps();
}

/****************************************************************************************/
void HatNameWindow::deleteHatRow() {

    QItemSelectionModel *selection = vueFichiers->selectionModel();
    QModelIndex indexElementSelectionne = selection->currentIndex();
    QVariant elementSelectionne = modeleFichiers->data(indexElementSelectionne, Qt::DisplayRole);

     listeFichiers.removeOne(elementSelectionne.toString());//Retrait de l'élément sélectionné de l'objet QStringList
     modeleFichiers->setStringList(listeFichiers); //On indique au modèle la liste des éléments à afficher.

	-- compteur;
	testContenu(compteur);

     //testPresenceFichier();
  }

/****************************************************************************************/
void HatNameWindow::initialiserChamps() {

            m_comboHatName->clearEditText();
}

/****************************************************************************************/

/****************************************************************************************/
void HatNameWindow::ouvrirProjetExistant() {

  boiteDialogue = new QFileDialog(this); //Crée une boite de dialogue
     cheminFichier = boiteDialogue->getOpenFileName(this, tr("Insertion d'un fichier"), "./projects", tr("*.*")); //Retourne le chemin du fichier.
  m_comboHatName->setEditText(cheminFichier); //Affichage du resultat précédent dans le champ de saisie du nom du fichier.
}

/****************************************************************************************/
void HatNameWindow::testPresenceFichier() {

    if (listeFichiers.isEmpty())
       m_supHatName->setDisabled(true);
    else
       m_supHatName->setEnabled(true);
}
/****************************************************************************************/
vector<string> HatNameWindow::getTheHeaderList() {

    hatHeaderList.push_back("test");
    return hatHeaderList;
 }

/****************************************************************************************/
void HatNameWindow::setTheHeaderList(vector<string> theHeaderList) {



 }

/****************************************************************************************/
void HatNameWindow::setLocalProjectName(string name) {

    localProjectName = name;

}

/****************************************************************************************/
string HatNameWindow::getLocalProjectName() {

    return localProjectName;

}


/****************************************************************************************/
QStringList HatNameWindow::getHatList() {

    return listeFichiers;

 }
 /***************************************************************************************/
 
 bool HatNameWindow::testContenu(int anInt) {

	if (anInt != 0) {
		m_supHatName->setEnabled(true);
		m_enregHatName->setEnabled(true);
	}
	else
	{
		m_supHatName->setDisabled(true);
		m_enregHatName->setDisabled(true);
	}
}


